package {
  import flash.display.Sprite;
  import flash.events.MouseEvent;
  import flash.text.TextField;
  import flash.text.TextFieldAutoSize;
  
  // A magnet graphic
  public class Magnet extends Sprite {
    protected var label:TextField;
    protected var dragging:Boolean;
    
    public function Magnet () {
      mouseChildren = false;
      
      addEventListener(MouseEvent.MOUSE_DOWN, magnetMouseDownListener);
      addEventListener(MouseEvent.MOUSE_UP, magnetMouseUpListener, false, int.MAX_VALUE);
      
      label = new TextField();
      label.background = true;
      label.border = true;
      label.width = 20;
      label.height = 20;
      label.selectable = false;
      addChild(label);
    }
    
    public function setLabel (value:String):void {
      label.text = value;
    }
    
    public function isDragging ():Boolean {
      return dragging;
    }
    
    protected function magnetMouseDownListener (e:MouseEvent):void {
      startDrag();
      dragging = true;
    }
    
    protected function magnetMouseUpListener (e:MouseEvent):void {
      stopDrag();
      dragging = false;
    }
  }
}